//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;

namespace Bench
{
	/// <summary>
	/// Podsumowanie dla UnmanagedUdpTest.
	/// </summary>
	public class UnmanagedUdpTest : NetworkTest
	{
		public UnmanagedUdpTest(string server, int port, int numberOfPackets, int packetSize) :
			base(server, port, numberOfPackets, packetSize)
		{
			UnmanagedNetworking.SynchUdpTest(Server, Port, NumberOfPackets, PacketSize);
		}

		public override void Start()
		{
			// Wykonanie testu
			StartCounters();
			int startTime = Environment.TickCount;
				
			UnmanagedNetworking.Start();

			int endTime = Environment.TickCount;
			StopCounters();

			TransmitByteCount = UnmanagedNetworking.TransmitByteCount();
			ReceivedByteCount = UnmanagedNetworking.ReceivedByteCount();
			Elapsed = (float)UnmanagedNetworking.Elapsed();

			UnmanagedNetworking.Stop();
		}
	}
}
